Index: trunk/FACT++/gui/design.ui
===================================================================
--- trunk/FACT++/gui/design.ui	(revision 17217)
+++ trunk/FACT++/gui/design.ui	(revision 17257)
@@ -53,5 +53,5 @@
       </property>
       <property name="currentIndex">
-       <number>9</number>
+       <number>6</number>
       </property>
       <property name="documentMode">
@@ -7476,5 +7476,5 @@
                     </widget>
                    </item>
-                   <item row="4" column="1">
+                   <item row="5" column="1">
                     <widget class="QPushButton" name="fFadButtonFileFormatRaw">
                      <property name="text">
@@ -7597,5 +7597,5 @@
                     </widget>
                    </item>
-                   <item row="4" column="0">
+                   <item row="5" column="0">
                     <widget class="QPushButton" name="fFadLedFileFormatRaw">
                      <property name="enabled">
@@ -7642,5 +7642,5 @@
                     </widget>
                    </item>
-                   <item row="6" column="1">
+                   <item row="7" column="1">
                     <widget class="QPushButton" name="fDrsCalibStart2">
                      <property name="text">
@@ -7649,5 +7649,5 @@
                     </widget>
                    </item>
-                   <item row="8" column="1">
+                   <item row="9" column="1">
                     <widget class="QSpinBox" name="fDrsCalibBaseline2">
                      <property name="alignment">
@@ -7677,5 +7677,5 @@
                     </widget>
                    </item>
-                   <item row="9" column="1">
+                   <item row="10" column="1">
                     <widget class="QSpinBox" name="fDrsCalibGain2">
                      <property name="alignment">
@@ -7705,5 +7705,5 @@
                     </widget>
                    </item>
-                   <item row="6" column="0">
+                   <item row="7" column="0">
                     <widget class="QPushButton" name="fFadLedFileFormatCalib">
                      <property name="enabled">
@@ -7743,5 +7743,5 @@
                     </widget>
                    </item>
-                   <item row="8" column="0">
+                   <item row="9" column="0">
                     <widget class="QPushButton" name="fFadLedDrsBaseline">
                      <property name="enabled">
@@ -7781,5 +7781,5 @@
                     </widget>
                    </item>
-                   <item row="9" column="0">
+                   <item row="10" column="0">
                     <widget class="QPushButton" name="fFadLedDrsGain">
                      <property name="enabled">
@@ -7819,5 +7819,5 @@
                     </widget>
                    </item>
-                   <item row="10" column="1">
+                   <item row="11" column="1">
                     <widget class="QSpinBox" name="fDrsCalibTrgOffset2">
                      <property name="alignment">
@@ -7847,5 +7847,5 @@
                     </widget>
                    </item>
-                   <item row="10" column="0">
+                   <item row="11" column="0">
                     <widget class="QPushButton" name="fFadLedDrsTrgOff">
                      <property name="enabled">
@@ -7885,5 +7885,5 @@
                     </widget>
                    </item>
-                   <item row="11" column="1">
+                   <item row="12" column="1">
                     <widget class="QPushButton" name="fDrsCalibReset2">
                      <property name="text">
@@ -7892,5 +7892,5 @@
                     </widget>
                    </item>
-                   <item row="12" column="1">
+                   <item row="13" column="1">
                     <widget class="QSpinBox" name="fDrsCalibROI2">
                      <property name="alignment">
@@ -7920,8 +7920,53 @@
                     </widget>
                    </item>
-                   <item row="7" column="0" colspan="2">
+                   <item row="8" column="0" colspan="2">
                     <widget class="Line" name="line_59">
                      <property name="orientation">
                       <enum>Qt::Horizontal</enum>
+                     </property>
+                    </widget>
+                   </item>
+                   <item row="4" column="0">
+                    <widget class="QPushButton" name="fFadLedFileFormatZFits">
+                     <property name="enabled">
+                      <bool>true</bool>
+                     </property>
+                     <property name="sizePolicy">
+                      <sizepolicy hsizetype="Fixed" vsizetype="Minimum">
+                       <horstretch>0</horstretch>
+                       <verstretch>0</verstretch>
+                      </sizepolicy>
+                     </property>
+                     <property name="maximumSize">
+                      <size>
+                       <width>18</width>
+                       <height>16777215</height>
+                      </size>
+                     </property>
+                     <property name="text">
+                      <string/>
+                     </property>
+                     <property name="icon">
+                      <iconset resource="design.qrc">
+                       <normaloff>:/Resources/icons/gray circle 1.png</normaloff>:/Resources/icons/gray circle 1.png</iconset>
+                     </property>
+                     <property name="iconSize">
+                      <size>
+                       <width>16</width>
+                       <height>16</height>
+                      </size>
+                     </property>
+                     <property name="checkable">
+                      <bool>false</bool>
+                     </property>
+                     <property name="flat">
+                      <bool>true</bool>
+                     </property>
+                    </widget>
+                   </item>
+                   <item row="4" column="1">
+                    <widget class="QPushButton" name="fFadButtonFileFormatZFits">
+                     <property name="text">
+                      <string>ZFITS</string>
                      </property>
                     </widget>
@@ -17591,6 +17636,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1319</x>
-     <y>849</y>
+     <x>1252</x>
+     <y>870</y>
     </hint>
     <hint type="destinationlabel">
@@ -17607,6 +17652,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1380</x>
-     <y>849</y>
+     <x>1313</x>
+     <y>870</y>
     </hint>
     <hint type="destinationlabel">
@@ -17623,6 +17668,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1415</x>
-     <y>849</y>
+     <x>1348</x>
+     <y>870</y>
     </hint>
     <hint type="destinationlabel">
@@ -17639,5 +17684,5 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1308</x>
+     <x>1241</x>
      <y>109</y>
     </hint>
@@ -17655,5 +17700,5 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1369</x>
+     <x>1302</x>
      <y>109</y>
     </hint>
@@ -17671,5 +17716,5 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1404</x>
+     <x>1337</x>
      <y>109</y>
     </hint>
@@ -17687,10 +17732,10 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1347</x>
-     <y>772</y>
+     <x>1280</x>
+     <y>793</y>
     </hint>
     <hint type="destinationlabel">
-     <x>1404</x>
-     <y>773</y>
+     <x>1337</x>
+     <y>794</y>
     </hint>
    </hints>
@@ -17703,5 +17748,5 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1308</x>
+     <x>1241</x>
      <y>105</y>
     </hint>
@@ -17719,5 +17764,5 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1369</x>
+     <x>1302</x>
      <y>105</y>
     </hint>
@@ -17735,5 +17780,5 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1404</x>
+     <x>1337</x>
      <y>105</y>
     </hint>
@@ -17771,6 +17816,6 @@
     </hint>
     <hint type="destinationlabel">
-     <x>1404</x>
-     <y>465</y>
+     <x>1337</x>
+     <y>539</y>
     </hint>
    </hints>
@@ -17783,10 +17828,10 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1347</x>
-     <y>772</y>
+     <x>1280</x>
+     <y>793</y>
     </hint>
     <hint type="destinationlabel">
-     <x>1404</x>
-     <y>773</y>
+     <x>1337</x>
+     <y>794</y>
     </hint>
    </hints>
@@ -17819,6 +17864,6 @@
     </hint>
     <hint type="destinationlabel">
-     <x>1404</x>
-     <y>298</y>
+     <x>1337</x>
+     <y>372</y>
     </hint>
    </hints>
@@ -17851,6 +17896,6 @@
     </hint>
     <hint type="destinationlabel">
-     <x>1404</x>
-     <y>244</y>
+     <x>1337</x>
+     <y>318</y>
     </hint>
    </hints>
@@ -17895,6 +17940,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1308</x>
-     <y>486</y>
+     <x>1241</x>
+     <y>498</y>
     </hint>
     <hint type="destinationlabel">
@@ -17911,6 +17956,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1369</x>
-     <y>486</y>
+     <x>1302</x>
+     <y>498</y>
     </hint>
     <hint type="destinationlabel">
@@ -17927,6 +17972,6 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1404</x>
-     <y>486</y>
+     <x>1337</x>
+     <y>498</y>
     </hint>
     <hint type="destinationlabel">
@@ -17943,9 +17988,9 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1404</x>
+     <x>1337</x>
      <y>438</y>
     </hint>
     <hint type="destinationlabel">
-     <x>1404</x>
+     <x>1337</x>
      <y>399</y>
     </hint>
@@ -17959,9 +18004,9 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1404</x>
+     <x>1337</x>
      <y>438</y>
     </hint>
     <hint type="destinationlabel">
-     <x>1404</x>
+     <x>1337</x>
      <y>374</y>
     </hint>
@@ -17975,9 +18020,9 @@
    <hints>
     <hint type="sourcelabel">
-     <x>1404</x>
+     <x>1337</x>
      <y>438</y>
     </hint>
     <hint type="destinationlabel">
-     <x>1404</x>
+     <x>1337</x>
      <y>349</y>
     </hint>